RegistrationServicelmpl.page( .... Collection<UUID> typeDesignationStatusUuids ... ) fails when NULL
and UUIDs are passed
Description

In case the collection of typeDesignationStatusUuids contains both, a null value and UUIDs the request fails.

This is caused by a bug in CdmEntityDaoBase.addRestrictions(List<Restriction<?>> restrictions, DetachedCriteria criteria) where the
implementation fails to distinguish aliases for different JOIN methods. This causes the method to attempt create the same alias name
two times, which finally result in:

org.hibernate.QueryException: duplicate alias: typeDesignations

at org.hibernate.loader.criteria.CriteriaQueryTranslator.createAliasCriteriaMap (CriteriaQueryT
ranslator. java:141)

at org.hibernate.loader.criteria.CriteriaQueryTranslator.<init>(CriteriaQueryTranslator.java:9

2)

at org.hibernate.loader.criteria.CriteriaQueryTranslator.<init>(CriteriaQueryTranslator. java:7
8)

at org.hibernate.criterion.SubqueryExpression.createAndSetInnerQuery (SubqueryExpression. java:l
29)

at org.hibernate.criterion.SubqueryExpression.toSqglString (SubqueryExpression.java:61)

at org.hibernate.loader.criteria.CriteriaQueryTranslator.getWhereCondition (CriteriaQueryTransl
ator.java:400)

at org.hibernate.loader.criteria.CriteriadoinWalker.<init> (CriteriaJoinWalker. java:95)

at org.hibernate.loader.criteria.CriteriadoinWalker.<init> (CriteriaJdoinWalker. java:75)

at org.hibernate.loader.criteria.Criterialoader.<init> (CriteriaLoader. java:80)

at org.hibernate.internal.SessionImpl.list (SessionImpl.java:1760)

at org.hibernate.internal.CriteriaImpl.list (CriteriaImpl. java:363)

at org.hibernate.internal.CriteriaImpl.uniqueResult (CriteriaImpl.java:385)

at eu.etaxonomy.cdm.persistence.dao.hibernate.common.CdmEntityDaoBase.count (CdmEntityDaoBase. j
ava:691)

at eu.etaxonomy.cdm.api.service.RegistrationServiceImpl.page (RegistrationServiceImpl. java:183)

This problem would actually not become relevant if the the RegistrationServicelmpl.page( .... Collection<UUID>
typeDesignationStatusUuids ... ) could be implemented so that the Restriction for typeDesignationStatus=NULL OR
typeDesignationStatus.uuis IN (...) would be enclosed in "brackets", which currently is not yet possible with the cdm-Restrictions.

Regarding the page method it would be best to implement a dedicated dao method with tests instead of using the generic list
methods with Restriction parameters.

TODO:

1. implement dedicated dao method #8330
2. re-enable search form multiselect, see cdm-dataportal|la0d2a22c

Related issues:
Related to EDIT - feature request #8330: RegistrationDao search method Closed
Copied from EDIT - feature request #7966: Registration search simplify type s... Closed

Associated revisions

Revision a0d2a22c - 05/20/2019 01:01 PM - Andreas Kohlbecker

ref #8287 comment to re-enable multi selection of options once the web service bug is fixed
https://dev.e-taxonomy.eu/redmine/issues/8330
https://dev.e-taxonomy.eu/redmine/projects/edit/repository/cdm-dataportal/revisions/a0d2a22c7fa448440dd755d01ab2e0c56b31a626

Revision c40f420c - 07/02/2019 03:10 PM - Andreas Kohlbecker

fix #8287 implementing support for null type status as filter value in Registration service

Revision 88131480 - 07/02/2019 03:19 PM - Andreas Kohlbecker

ref #8287 re-enabling type status filter multiple options

History

#1 - 05/20/2019 12:57 PM - Andreas Kohlbecker

- Copied from feature request #7966: Registration search simplify type select options added

#2 - 05/20/2019 01:03 PM - Andreas Kohlbecker
- Description updated

#3 - 06/06/2019 05:59 PM - Andreas Kohlbecker
- Related to feature request #8330: RegistrationDao search method added

#4 - 06/06/2019 06:00 PM - Andreas Kohlbecker
- Description updated

#5 - 06/06/2019 06:00 PM - Andreas Kohlbecker

- Status changed from New to In Progress

#6 - 07/02/2019 03:10 PM - Andreas Kohlbecker
- Status changed from In Progress to Resolved

- % Done changed from 0 to 50

Applied in changeset cdmlib|c40f420c355ee29b3b31e575¢8d630f59cf55¢0e.

#7 - 07/02/2019 03:11 PM - Andreas Kohlbecker

- Assignee changed from Andreas Kohlbecker to Wolf-Henning Kusber

please review

#8 - 07/02/2019 03:11 PM - Andreas Kohlbecker

- Target version changed from Release 5.10 to Release 5.8

#9 - 07/17/2019 07:28 PM - Wolf-Henning Kusber
- Assignee changed from Wolf-Henning Kusber to Andreas Kohlbecker

- % Done changed from 50 to 100

combination of types and none are searchable without errors in Vaadin and the portal. If this is the feedback for this ticket, it can be closed.

#10 - 07/18/2019 08:16 AM - Andreas Kohlbecker

- Status changed from Resolved to Closed
